    001/* ===========================================================
    002 * Orson Charts : a 3D chart library for the Java(tm) platform
    003 * ===========================================================
    004 *
    005 * (C)opyright 2013-2022, by David Gilbert.  All rights reserved.
    006 *
    007 * https://github.com/jfree/orson-charts
    008 *
    009 * This program is free software: you can redistribute it and/or modify
    010 * it under the terms of the GNU General Public License as published by
    011 * the Free Software Foundation, either version 3 of the License, or
    012 * (at your option) any later version.
    013 *
    014 * This program is distributed in the hope that it will be useful,
    015 * but WITHOUT ANY WARRANTY; without even the implied warranty of
    016 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    017 * GNU General Public License for more details.
    018 *
    019 * You should have received a copy of the GNU General Public License
    020 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
    021 *
    022 * [Oracle and Java are registered trademarks of Oracle and/or its affiliates.
    023 * Other names may be trademarks of their respective owners.]
    024 *
    025 * If you do not wish to be bound by the terms of the GPL, an alternative
    026 * commercial license can be purchased.  For details, please see visit the
    027 * Orson Charts home page:
    028 *
    029 * http://www.object-refinery.com/orsoncharts/index.html
    030 *
    031 */
    032
    033package org.jfree.chart3d.renderer;
    034
    035import java.util.EventObject;
    036
    037/**
    038 * An event containing information about a change to a {@link Renderer3D}.
    039 * Any object that implements the {@link Renderer3DChangeListener} interface
    040 * can register with a renderer to receive change event notifications.  By
    041 * default, the plot classes register with the renderer they manage in order
    042 * to monitor changes to the renderer.
    043 * <br><br>
    044 * NOTE: This class is serializable, but the serialization format is subject
    045 * to change in future releases and should not be relied upon for persisting
    046 * instances of this class.
    047 */
    048@SuppressWarnings("serial")
    049public class Renderer3DChangeEvent extends EventObject {
    050
    051    private Renderer3D renderer;
    052
    053    private boolean requiresWorldUpdate;
    054
    055    /**
    056     * Creates a new change event.
    057     *
    058     * @param renderer  the renderer that changed ({@code null} not permitted).
    059     * @param requiresWorldUpdate  a flag indicating whether or not the change
    060     *     requires the 3D world to be updated.
    061     */
    062    public Renderer3DChangeEvent(Renderer3D renderer,
    063            boolean requiresWorldUpdate) {
    064        this(renderer, renderer, requiresWorldUpdate);
    065    }
    066
    067    /**
    068     * Creates a new change event.
    069     *
    070     * @param source  the source.
    071     * @param renderer  the renderer.
    072     * @param requiresWorldUpdate  a flag indicating whether or not the change
    073     *     requires the 3D world to be updated.
    074     */
    075    public Renderer3DChangeEvent(Object source, Renderer3D renderer,
    076            boolean requiresWorldUpdate) {
    077        super(source);
    078        this.renderer = renderer;
    079        this.requiresWorldUpdate = requiresWorldUpdate;
    080    }
    081
    082    /**
    083     * Returns the renderer that the event relates to.
    084     *
    085     * @return The renderer.
    086     */
    087    public Renderer3D getRenderer() {
    088        return this.renderer;
    089    }
    090
    091    /**
    092     * Returns the flag that indicates whether or not this change will require
    093     * the 3D world to be updated.
    094     *
    095     * @return A boolean.
    096     *
    097     * @since 1.2
    098     */
    099    public boolean requiresWorldUpdate() {
    100        return this.requiresWorldUpdate;
    101    }
    102
    103}